
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Referral_linksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const referral_links = await db.referral_links.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        landing_url: data.landing_url
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        created_on: data.created_on
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await referral_links.setReferrer_user( data.referrer_user || null, {
            transaction,
        });
        
        await referral_links.setProgram( data.program || null, {
            transaction,
        });
        
        await referral_links.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return referral_links;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const referral_linksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                landing_url: item.landing_url
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                created_on: item.created_on
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const referral_links = await db.referral_links.bulkCreate(referral_linksData, { transaction });

        // For each item created, replace relation files
        

        return referral_links;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const referral_links = await db.referral_links.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.landing_url !== undefined) updatePayload.landing_url = data.landing_url;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.created_on !== undefined) updatePayload.created_on = data.created_on;
        
        
        updatePayload.updatedById = currentUser.id;

        await referral_links.update(updatePayload, {transaction});

        
        
        if (data.referrer_user !== undefined) {
            await referral_links.setReferrer_user(
              
              data.referrer_user,
              
              { transaction }
            );
        }
        
        if (data.program !== undefined) {
            await referral_links.setProgram(
              
              data.program,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await referral_links.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return referral_links;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const referral_links = await db.referral_links.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of referral_links) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of referral_links) {
                await record.destroy({transaction});
            }
        });


        return referral_links;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const referral_links = await db.referral_links.findByPk(id, options);

        await referral_links.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await referral_links.destroy({
            transaction
        });

        return referral_links;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const referral_links = await db.referral_links.findOne(
            { where },
            { transaction },
        );

        if (!referral_links) {
            return referral_links;
        }

        const output = referral_links.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.referral_conversions_referral_link = await referral_links.getReferral_conversions_referral_link({
            transaction
        });
        
        
        
        output.referrer_user = await referral_links.getReferrer_user({
            transaction
        });
        
        
        output.program = await referral_links.getProgram({
            transaction
        });
        
        
        output.organizations = await referral_links.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'referrer_user',
        
        where: filter.referrer_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.referrer_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.referrer_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.referral_programs,
        as: 'program',
        
        where: filter.program ? {
          [Op.or]: [
            { id: { [Op.in]: filter.program.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.program.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'referral_links',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.landing_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'referral_links',
                        'landing_url',
                        filter.landing_url,
                    ),
                };
            }
            

            
            

            
            if (filter.created_onRange) {
                const [start, end] = filter.created_onRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_on: {
                    ...where.created_on,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_on: {
                    ...where.created_on,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.referral_links.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'referral_links',
                        'code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.referral_links.findAll({
            attributes: [ 'id', 'code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.code,
        }));
    }

    
};

